 #include <iostream>
 #include <vector>
 #include <cmath>
 #include <algorithm>

 using namespace std;

 vector< vector< long long> > graph;
 vector<int> used;


long long theLongestW(long long deep, long long cunt, long long res1 = 0)
 {
    //cout<<"deb"<<endl;
    long long res = res1;
    if (graph[deep].empty())
    {
        //cout<<"E! deep: "<<deep<<endl<<"cunt: "<<cunt<<endl<<endl;
        return cunt;
    };
    for (long long i = 0; i < graph[deep].size(); i++)
    {
        long long to = graph[deep][i];
        res = max(theLongestW(to, cunt + 1), res);
    };
    return res;
 }

long long secW(long long deep)
{
    //cout<<"deb"<<endl;
    long long fmx = 0, smx = 0, next = deep, sum = 0;
    for (int i = 0; i < graph[deep].size(); i++)
    {
        long long to = theLongestW(graph[deep][i], 0) + 1;
        if (fmx < to)
        {
            next = graph[deep][i];
            smx = fmx;
            fmx = to;
        } else if (smx < to && to <= fmx)
        {
            smx = to;
        };
         //cout<<smx<<"__"<<fmx<<" "<<to<<endl;
    };
    long long res = smx + fmx;
    if (next != deep)
    {
        sum = secW(next);
    };
    return max(res, sum);
};


/* {
    static long long res = 0;
    cout<<deep + 1<<" "<<cunt<<endl;
    if (graph[deep].empty())
    {
        used[deep] = 1;
        return cunt;
    };
    long long fmx = 0, smx = 0;
    for (long long i = 0; i < graph[deep].size(); i++)
    {
        if (used[graph[deep][i]] == 0)
        {
            used[graph[deep][i]] = 1;
            long long to = graph[deep][i];
            long long tmp = secW(to, cunt+1);
            if (tmp >= fmx)
            {
                cout<<i<<" 2)"<<endl;
                cout<<smx<<"__"<<fmx<<" "<<tmp<<endl;
                smx = fmx;
                fmx = tmp;
            } else if (tmp > smx)
            {
                cout<<i<<" 1)"<<endl;
                smx = tmp;
            };
            cout<<smx<<"__"<<fmx<<" "<<tmp<<endl;

        };
    };
    res = max(res, smx+fmx);
    return res;
 }*/
 /*{
     //static vector<int> used(n);
     static long long sum = 0;
     static long long cunt = 0;
     cunt++;
     if(graph[deep].empty())
     {
            //used[deep] = 1;
            return cunt;
     } else if (graph[deep].size() == 1)
     {
         //used[graph[deep][0]] = 1;
         return secW(graph[deep][0], n);
     } else
     {
         long long firstMx = 0, secMx = 0;
         for (long long i = 0; i < graph[deep].size(); i++)
         {
             long long to = secW(graph[deep][i], n);
             if (firstMx < to)
             {
                 secMx = firstMx;
                 firstMx = to;
             } else if (secMx < to)
             {
                 secMx = to;
             };
         };
         sum = max(sum, firstMx + secMx);
     //};
     cunt--;
     return sum;
 } */

 int main()
 {
     long long n, m;
     cin>>n>>m;
     long long inp;
     for (long long i = 0; i < n; i++)
     {
         used.push_back(0);
         vector<long long> tmp;
         graph.push_back(tmp);
     };
     for (long long i = 1; i < n; i++)
     {
         cin>>inp;
         graph[inp-1].push_back(i);
     };
     /*for (long long i = 0; i < n; i++)
     {
         for (int j = 0; j < graph[i].size(); j++)
         {
             cout<<graph[i][j]<<" ";
         };
         cout<<endl;
     };*/
     //cout<<"deb"<<endl;
     long long baseA = theLongestW(0, 0) + 1;
     long long baseB = secW(0) + 1;
    cout<<baseB + baseA*2*(m-1);

 }
